--------------------------------------------------------
--  DDL for Function F_GET_GPRS_SIMILARITY
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "F_GET_GPRS_SIMILARITY" (x_rec in GPRS_STAT_TYPE, y_rec in GPRS_STAT_TYPE)
return NUMBER
IS
  v_sum NUMBER;
BEGIN
    v_sum := 0;
--    v_sum := v_sum + power(x_rec.GPRS_EVENTS - y_rec.GPRS_EVENTS,2);
--    v_sum := v_sum + power(x_rec.GPRS_SUM_AMOUNT - y_rec.GPRS_SUM_AMOUNT,2);
--    v_sum := v_sum + power(x_rec.GPRS_MAX_AMOUNT - y_rec.GPRS_MAX_AMOUNT,2);
--    v_sum := v_sum + power(x_rec.GPRS_MIN_AMOUNT - y_rec.GPRS_MIN_AMOUNT,2);
--    v_sum := v_sum + power(x_rec.GPRS_AVG_AMOUNT - y_rec.GPRS_AVG_AMOUNT,2);
--    
--    v_sum := 1 / (1 + sqrt(v_sum));
--    v_sum := round(v_sum,5);

    if greatest(x_rec.GPRS_EVENTS, y_rec.GPRS_EVENTS) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.GPRS_EVENTS, y_rec.GPRS_EVENTS) / greatest(x_rec.GPRS_EVENTS, y_rec.GPRS_EVENTS);
    end if;
    
    if greatest(x_rec.GPRS_SUM_AMOUNT, y_rec.GPRS_SUM_AMOUNT) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.GPRS_SUM_AMOUNT, y_rec.GPRS_SUM_AMOUNT) / greatest(x_rec.GPRS_SUM_AMOUNT, y_rec.GPRS_SUM_AMOUNT);
    end if;
    
    if greatest(x_rec.GPRS_MAX_AMOUNT, y_rec.GPRS_MAX_AMOUNT) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.GPRS_MAX_AMOUNT, y_rec.GPRS_MAX_AMOUNT) / greatest(x_rec.GPRS_MAX_AMOUNT, y_rec.GPRS_MAX_AMOUNT);
    end if;
    
    if greatest(x_rec.GPRS_MIN_AMOUNT, y_rec.GPRS_MIN_AMOUNT) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.GPRS_MIN_AMOUNT, y_rec.GPRS_MIN_AMOUNT) / greatest(x_rec.GPRS_MIN_AMOUNT, y_rec.GPRS_MIN_AMOUNT);
    end if;

    if greatest(x_rec.GPRS_AVG_AMOUNT, y_rec.GPRS_AVG_AMOUNT) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.GPRS_AVG_AMOUNT, y_rec.GPRS_AVG_AMOUNT) / greatest(x_rec.GPRS_AVG_AMOUNT, y_rec.GPRS_AVG_AMOUNT);
    end if;  
    
RETURN round((1/5) * v_sum,5);
END F_GET_GPRS_SIMILARITY;
