--------------------------------------------------------
--  DDL for Function F_GET_MTC_SIMILARITY
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "F_GET_MTC_SIMILARITY" (x_rec in MTC_STAT_TYPE, y_rec in MTC_STAT_TYPE)
return NUMBER
IS
  v_sum NUMBER;
BEGIN
    v_sum := 0;
--    v_sum := v_sum + power(x_rec.MTC_EVENTS - y_rec.MTC_EVENTS,2);
--    v_sum := v_sum + power(x_rec.MTC_SUM_DURATION - y_rec.MTC_SUM_DURATION,2);
--    v_sum := v_sum + power(x_rec.MTC_MAX_DURATION - y_rec.MTC_MAX_DURATION,2);
--    v_sum := v_sum + power(x_rec.MTC_MIN_DURATION - y_rec.MTC_MIN_DURATION,2);
--    v_sum := v_sum + power(x_rec.MTC_AVG_DURATION - y_rec.MTC_AVG_DURATION,2);
--    v_sum := 1 / (1 + sqrt(v_sum));
--    v_sum := round(v_sum,5);

    if greatest(x_rec.MTC_EVENTS, y_rec.MTC_EVENTS) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.MTC_EVENTS, y_rec.MTC_EVENTS) / greatest(x_rec.MTC_EVENTS, y_rec.MTC_EVENTS);
    end if;

    if greatest(x_rec.MTC_SUM_DURATION, y_rec.MTC_SUM_DURATION) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.MTC_SUM_DURATION, y_rec.MTC_SUM_DURATION) / greatest(x_rec.MTC_SUM_DURATION, y_rec.MTC_SUM_DURATION);
    end if;
    
    if greatest(x_rec.MTC_MAX_DURATION, y_rec.MTC_MAX_DURATION) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.MTC_MAX_DURATION, y_rec.MTC_MAX_DURATION) / greatest(x_rec.MTC_MAX_DURATION, y_rec.MTC_MAX_DURATION);
    end if;
    
    if greatest(x_rec.MTC_MIN_DURATION, y_rec.MTC_MIN_DURATION) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.MTC_MIN_DURATION, y_rec.MTC_MIN_DURATION) / greatest(x_rec.MTC_MIN_DURATION, y_rec.MTC_MIN_DURATION);
    end if;

    if greatest(x_rec.MTC_AVG_DURATION, y_rec.MTC_AVG_DURATION) = 0 then
      v_sum := v_sum + 1;
    else
      v_sum := v_sum + least(x_rec.MTC_AVG_DURATION, y_rec.MTC_AVG_DURATION) / greatest(x_rec.MTC_AVG_DURATION, y_rec.MTC_AVG_DURATION);
    end if;   

RETURN round((1/5) * v_sum,5);
END F_GET_MTC_SIMILARITY;
