CREATE OR REPLACE FORCE VIEW "V_SUBS_SIM_FILTERED" ("OBJ_COMP", "SUBSCRIBER_ID_X", "SUBSCRIBER_ID_Y", "MOC_SIMILARITY", "MTC_SIMILARITY", "GPRS_SIMILARITY", "SIMILARITY") AS 
  select   LEAST(ss.SUBSCRIBER_ID_X,ss.SUBSCRIBER_ID_Y) || '_' || GREATEST(ss.SUBSCRIBER_ID_X,ss.SUBSCRIBER_ID_Y) as OBJ_COMP
        ,min(ss.SUBSCRIBER_ID_X) SUBSCRIBER_ID_X
        ,max(ss.SUBSCRIBER_ID_Y) SUBSCRIBER_ID_Y
        ,max(MOC_SIMILARITY) MOC_SIMILARITY
        ,max(MTC_SIMILARITY) MTC_SIMILARITY
        ,max(GPRS_SIMILARITY) GPRS_SIMILARITY
        ,max(ss.SIMILARITY) SIMILARITY
from SUBSCRIBER_SIMILARITY ss
group by LEAST(ss.SUBSCRIBER_ID_X,ss.SUBSCRIBER_ID_Y) || '_' || GREATEST(ss.SUBSCRIBER_ID_X,ss.SUBSCRIBER_ID_Y);